﻿/// <summary>
/// source: Http://www.WayneCliffordBarker.co.za
/// license: free to use by any individual or company for what ever purpose.
/// disclaimer: All content provided on this site "www.waynecliffordbarker.co.za" is for informational purposes only. Although the owner takes care to represent accurate content, the owner makes no representations as to the accuracy or completeness of any information on this site or found by following any link on this site. Neither the  owner of www.waynecliffordbarker.co.za nor any author of the site will be liable for any errors or omissions in this information nor for the availability of this information. The owner of www.waynecliffordbarker.co.za nor any author of the site will not be liable for any losses, injuries, or damages from the display or use of this information obtained from this site.
/// </summary>

using System;
using System.Collections.Generic;
using System.Text;
using WayneCliffordBarker.RoutingEngine.Concerete;
using WayneCliffordBarker.RoutingEngine.Interface;
using WayneCliffordBarker.RoutingEngine.Model;

namespace WayneCliffordBarker.RoutingEngine.Abstract
{
    public abstract class DataPacketIdentifier
    {
        protected string compareTarget { get; set; }

        protected internal Ilogger Logger { get; set; }

        public DataPacketIdentifier()
        {
            this.compareTarget = null;
        }

        public DataPacketIdentifier(string compareTarget)
        {
            this.compareTarget = compareTarget;
        }

        public bool Identify(DataPacket data)
        {
            bool result;

            this?.Logger?.WriteInformation("Identifying data");
            result = ContentIdentified(data);
            this?.Logger?.WriteInformation("Data identified" + this.GetType());

            return result;
        }

        protected abstract bool ContentIdentified(DataPacket data);

    }
}
