﻿/// <summary>
/// source: Http://www.WayneCliffordBarker.co.za
/// license: free to use by any individual or company for what ever purpose.
/// disclaimer: All content provided on this site "www.waynecliffordbarker.co.za" is for informational purposes only. Although the owner takes care to represent accurate content, the owner makes no representations as to the accuracy or completeness of any information on this site or found by following any link on this site. Neither the  owner of www.waynecliffordbarker.co.za nor any author of the site will be liable for any errors or omissions in this information nor for the availability of this information. The owner of www.waynecliffordbarker.co.za nor any author of the site will not be liable for any losses, injuries, or damages from the display or use of this information obtained from this site.
/// </summary>

using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using WayneCliffordBarker.RoutingEngine.Abstract;

namespace WayneCliffordBarker.RoutingEngine.Persisters

{
    public class WriteFileToDisk : PersistMechanism
    {
        public WriteFileToDisk(string FileLocation) : base()
        {
            this.FileLocation = FileLocation;
        }

        public string FileLocation { get; set; }

        protected override bool PersistData(IEnumerable<string> data)
        {
            string dataString = string.Join<string>("\r\n", data);

            string dirName = Path.GetDirectoryName(FileLocation);

            if (!Directory.Exists(dirName))
            {
                this?.Logger?.WriteInformation("Directory '"+ dirName + "' does not exist, creating...");

                Directory.CreateDirectory(dirName);
            }

            this?.Logger?.WriteInformation("Writing file to " + FileLocation);
            File.WriteAllText(FileLocation, dataString);

            return true;
        }
    }
}
