﻿/// <summary>
/// source: Http://www.WayneCliffordBarker.co.za
/// license: free to use by any individual or company for what ever purpose.
/// disclaimer: All content provided on this site "www.waynecliffordbarker.co.za" is for informational purposes only. Although the owner takes care to represent accurate content, the owner makes no representations as to the accuracy or completeness of any information on this site or found by following any link on this site. Neither the  owner of www.waynecliffordbarker.co.za nor any author of the site will be liable for any errors or omissions in this information nor for the availability of this information. The owner of www.waynecliffordbarker.co.za nor any author of the site will not be liable for any losses, injuries, or damages from the display or use of this information obtained from this site.
/// </summary>

using System;
using System.Collections.Generic;
using System.IO;
using System.Net;
using System.Text;
using WayneCliffordBarker.RoutingEngine.Abstract;

namespace WayneCliffordBarker.RoutingEngine.Persisters
{
    public class WriteFileToFtp : PersistMechanism
    {
        public Uri FTPServerFile { get; set; }

        public string Username { get; set; }

        public string Password { get; set; }

        public string FileName { get; set; }

        public WriteFileToFtp(Uri FTPServerFile, string Username, string Password)
        {
            this.FTPServerFile = FTPServerFile;
            this.Username = Username;
            this.Password = Password;
        }

        protected override bool PersistData(IEnumerable<string> data)
        {
            FtpWebRequest request = (FtpWebRequest)WebRequest.Create(this.FTPServerFile);
            request.Method = WebRequestMethods.Ftp.UploadFile;

            // This example assumes the FTP site uses anonymous logon.
            request.Credentials = new NetworkCredential(this.Username, this.Password);
            
            // Copy the contents of the file to the request stream.
            byte[] fileContents;
            string dataString = string.Join<string>("\r\n", data);

            fileContents = Encoding.UTF8.GetBytes(dataString);
            request.ContentLength = fileContents.Length;

            using (Stream requestStream = request.GetRequestStream())
            {
                requestStream.Write(fileContents, 0, fileContents.Length);
            }

            using (FtpWebResponse response = (FtpWebResponse)request.GetResponse())
            {
                Logger.WriteInformation($"Upload File Complete, status {response.StatusDescription}");
            }

            return true;
        }
    }
}
